The Synthesis ToolKit in C++ (STK)

Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

# stk::DelayA Class Reference

STK allpass interpolating delay line class. More...

`#include <DelayA.h>`

Inheritance diagram for stk::DelayA:

List of all members.

## Public Member Functions
| DelayA (StkFloat delay=0.5, unsigned long maxDelay=4095)
| Default constructor creates a delay-line with maximum length of 4095 samples and delay = 0.5.
| ~DelayA ()
| Class destructor.
void | clear (void)
| Clears all internal states of the delay line.
unsigned long | getMaximumDelay (void)
| Get the maximum delay-line length.
void | setMaximumDelay (unsigned long delay)
| Set the maximum delay-line length.
void | setDelay (StkFloat delay)
| Set the delay-line length.
StkFloat | getDelay (void) const
| Return the current delay-line length.
StkFloat | tapOut (unsigned long tapDelay)
| Return the value at tapDelay samples from the delay-line input.
void | tapIn (StkFloat value, unsigned long tapDelay)
| Set the value at tapDelay samples from the delay-line input.
StkFloat | lastOut (void) const
| Return the last computed output value.
StkFloat | nextOut (void)
| Return the value which will be output by the next call to tick().
StkFloat | tick (StkFloat input)
| Input one sample to the filter and return one output.
StkFrames & | tick (StkFrames &frames, unsigned int channel=0)
| Take a channel of the StkFrames object as inputs to the filter and replace with corresponding outputs.
StkFrames & | tick (StkFrames &iFrames, StkFrames &oFrames, unsigned int iChannel=0, unsigned int oChannel=0)
| Take a channel of the `iFrames` object as inputs to the filter and write outputs to the `oFrames` object.

## Detailed Description

STK allpass interpolating delay line class.

This class implements a fractional-length digital delay-line using a first-order allpass filter. If the delay and maximum length are not specified during instantiation, a fixed maximum length of 4095 and a delay of 0.5 is set.

An allpass filter has unity magnitude gain but variable phase delay properties, making it useful in achieving fractional delays without affecting a signal's frequency magnitude response. In order to achieve a maximally flat phase delay response, the minimum delay possible in this implementation is limited to a value of 0.5.

by Perry R. Cook and Gary P. Scavone, 1995-2012.

## Constructor & Destructor Documentation

stk::DelayA::DelayA | ( | StkFloat | delay = `0.5`,
|  | unsigned long | maxDelay = `4095` |
| ) |  |  |

Default constructor creates a delay-line with maximum length of 4095 samples and delay = 0.5.

An StkError will be thrown if the delay parameter is less than zero, the maximum delay parameter is less than one, or the delay parameter is greater than the maxDelay value.

## Member Function Documentation

void stk::DelayA::setMaximumDelay | ( | unsigned long | delay | ) |

Set the maximum delay-line length.

This method should generally only be used during initial setup of the delay line. If it is used between calls to the tick() function, without a call to clear(), a signal discontinuity will likely occur. If the current maximum length is greater than the new length, no memory allocation change is made.

void stk::DelayA::setDelay | ( | StkFloat | delay | ) |

Set the delay-line length.

The valid range for delay is from 0.5 to the maximum delay-line length.

StkFloat stk::DelayA::tapOut | ( | unsigned long | tapDelay | ) |

Return the value at tapDelay samples from the delay-line input.

The tap point is determined modulo the delay-line length and is relative to the last input value (i.e., a tapDelay of zero returns the last input value).

StkFloat stk::DelayA::nextOut | ( | void |  | ) | `[inline]`

Return the value which will be output by the next call to tick().

This method is valid only for delay settings greater than zero!

    00126 {
    00127   if ( doNextOut_ ) {
    00128     // Do allpass interpolation delay.
    00129     nextOutput_ = -coeff_ * lastFrame_[0];
    00130     nextOutput_ += apInput_ + ( coeff_ * inputs_[outPoint_] );
    00131     doNextOut_ = false;
    00132   }
    00133
    00134   return nextOutput_;
    00135 }

StkFrames & stk::DelayA::tick | ( | StkFrames & | frames,
|  | unsigned int | channel = `0` |
| ) |  |  | `[inline, virtual]`

Take a channel of the StkFrames object as inputs to the filter and replace with corresponding outputs.

The StkFrames argument reference is returned. The `channel` argument must be less than the number of channels in the StkFrames argument (the first channel is specified by 0). However, range checking is only performed if _STK_DEBUG_ is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

Implements stk::Filter.

    00157 {
    00158 #if defined(_STK_DEBUG_)
    00159   if ( channel >= frames.channels() ) {
    00160     oStream_ << "DelayA::tick(): channel and StkFrames arguments are incompatible!";
    00161     handleError( StkError::FUNCTION_ARGUMENT );
    00162   }
    00163 #endif
    00164
    00165   StkFloat *samples = &frames[channel];
    00166   unsigned int hop = frames.channels();
    00167   for ( unsigned int i=0; i<frames.frames(); i++, samples += hop ) {
    00168     inputs_[inPoint_++] = *samples * gain_;
    00169     if ( inPoint_ == inputs_.size() ) inPoint_ = 0;
    00170     *samples = nextOut();
    00171     lastFrame_[0] = *samples;
    00172     doNextOut_ = true;
    00173     apInput_ = inputs_[outPoint_++];
    00174     if ( outPoint_ == inputs_.size() ) outPoint_ = 0;
    00175   }
    00176
    00177   return frames;
    00178 }

StkFrames & stk::DelayA::tick | ( | StkFrames & | iFrames,
|  | StkFrames & | oFrames,
|  | unsigned int | iChannel = `0`,
|  | unsigned int | oChannel = `0` |
| ) |  |  | `[inline]`

Take a channel of the `iFrames` object as inputs to the filter and write outputs to the `oFrames` object.

The `iFrames` object reference is returned. Each channel argument must be less than the number of channels in the corresponding StkFrames argument (the first channel is specified by 0). However, range checking is only performed if _STK_DEBUG_ is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

    00181 {
    00182 #if defined(_STK_DEBUG_)
    00183   if ( iChannel >= iFrames.channels() || oChannel >= oFrames.channels() ) {
    00184     oStream_ << "DelayA::tick(): channel and StkFrames arguments are incompatible!";
    00185     handleError( StkError::FUNCTION_ARGUMENT );
    00186   }
    00187 #endif
    00188
    00189   StkFloat *iSamples = &iFrames[iChannel];
    00190   StkFloat *oSamples = &oFrames[oChannel];
    00191   unsigned int iHop = iFrames.channels(), oHop = oFrames.channels();
    00192   for ( unsigned int i=0; i<iFrames.frames(); i++, iSamples += iHop, oSamples += oHop ) {
    00193     inputs_[inPoint_++] = *iSamples * gain_;
    00194     if ( inPoint_ == inputs_.size() ) inPoint_ = 0;
    00195     *oSamples = nextOut();
    00196     lastFrame_[0] = *oSamples;
    00197     doNextOut_ = true;
    00198     apInput_ = inputs_[outPoint_++];
    00199     if ( outPoint_ == inputs_.size() ) outPoint_ = 0;
    00200   }
    00201
    00202   return iFrames;
    00203 }

The documentation for this class was generated from the following file:

- DelayA.h

The Synthesis ToolKit in C++ (STK)
©1995-2012 Perry R. Cook and Gary P. Scavone. All Rights Reserved.